#
# bncmake.inc
#
# ---------------------------------------------------
# Version Number
# ---------------------------------------------------
BNCVER=0.6b
# ---------------------------------------------------
# Install Directory
# ---------------------------------------------------
PREFIX=/usr/local
#PREFIX=/home/tkouya/local

# ---------------------------------------------------
# GMP, MPFR and MPI Directories
# ---------------------------------------------------
#GMPPREFIX=/usr
GMPPREFIX=/usr/local
#GMPPREFIX=/home/tkouya/local
#MPFRPREFIX=/usr
MPFRPREFIX=/usr/local
#MPFRPREFIX=/home/tkouya/local
MPIPREFIX=/usr
#MPIPREFIX=/usr/local/mpich-1.2.5
#MPIPREFIX=/usr/local/mpich-1.2.6
#MPIPREFIX=/usr/local/mpich2-1.0.1
#MPIPREFIX=/usr/local/mpich2-1.0.2p1

# ---------------------------------------------------
# Directories
# ---------------------------------------------------
BNCDIR = bnc-$(BNCVER)
SRC = src
ODE = ode
MPI = mpi
TEST = test
BENCH = bench
DOC = doc
WIN32 = win32
PTHREAD= pthread
LIBBNC = ../$(SRC)/libbnc.a
LIBODE = ../$(ODE)/libbncode.a
LIBMPI = ../$(MPI)/libmpibnc.a

# ---------------------------------------------------
# ---------------------------------------------------
# Compiler & Linker
# ---------------------------------------------------
CC = gcc
#MPICC = mpicc
MPICC = $(MPIPREFIX)/bin/mpicc 
AR = ar rc
CXREF = cxref
# ---------------------------------------------------

# ---------------------------------------------------
# Includes, Definitions and Libraries
# ---------------------------------------------------
# No GMP: Only IEEE754 float/double
# ---------------------------------------------------
#INCLUDES = -I/usr/local/include -I/usr/include -I../ -I./
#LIBS = -L/usr/local/lib:/usr/lib:./ $(LIBBNC) -lm
# ---------------------------------------------------
# USE_GMP
# ---------------------------------------------------
#INCLUDES = -DUSE_GMP -I/usr/local/include -I/usr/include -I../ -I./
#LIBS = -L/usr/local/lib:/usr/lib:./ $(LIBBNC) /usr/local/lib/libgmp.a -lm
# ---------------------------------------------------
# USE_GMP & USE_MPFR (/usr/local)
# ---------------------------------------------------
#DEFS = -DUSE_GMP -DUSE_MPFR
#INCLUDES = $(DEFS) -I/usr/local/include -I/usr/include -I../ -I./
#LIBS = -L/usr/local/lib -L/usr/lib -L./ $(LIBBNC) -lmpfr -lgmp -lm
# ---------------------------------------------------
# USE_GMP & USE_MPFR (home)
# ---------------------------------------------------
DEFS = -DUSE_GMP -DUSE_MPFR
INCLUDES = $(DEFS) -I$(GMPPREFIX)/include -I$(MPFRPREFIX)/include -I$(MPIPREFIX) -I/usr/local/include -I/usr/include -I../ -I./
LIBSDIR = -L$(GMPPREFIX)/lib -L$(MPFRPREFIX)/lib -L$(MPIPREFIX)/lib -L/usr/local/lib -L/usr/lib -L./
LIBS = $(LIBSDIR) $(LIBBNC) -lmpfr -lgmp -lm
LIBSODE = $(LIBSDIR) $(LIBBNC) $(LIBODE) -lmpfr -lgmp -lm
LIBSMPI = $(LIBSDIR) $(LIBBNC) $(LIBMPI) -lmpfr -lgmp -lm
