/**********************************************/
/* test_mpfprintb.c:                          */
/* Copyright (C) 2003 Tomonori Kouya          */
/*                                            */
/* This library is free software; you can re- */
/* distribute it and/or modify it under the   */
/* terms of the GNU Lesser General Public     */
/* License as published by the Free Software  */
/* Foundation; either version 2.1 of the      */
/* License, or (at your option) any later     */
/* version.                                   */
/*                                            */
/* This library is distributed in the hope    */
/* that it will be useful, but WITHOUT ANY    */
/* WARRANTY; without even the implied         */
/* warranty of MERCHANTABILITY or FITNESS FOR */
/* A PARTICULAR PURPOSE.  See the GNU Lesser  */
/* General Public License for more details.   */
/**********************************************/
#include <stdio.h>
#include "gmp.h"

main()
{
	long int digits, i, j, cdigits;
	mpf_t a;
	unsigned char mpfc[16384];

	for(i = 256; i <= 16384; i *= 2)
	{
		mpf_init2(a, i);
		mpf_sqrt_ui(a, 2);
		mpfc[0] = '\0';
		
		gmp_printf("2^(1/2) = %Fe", a);printf(" -> _mpf_struct:\n");
		printf("\t_mp_prec = %d(%d)\n", a->_mp_prec, 32 * (a->_mp_prec));
		printf("\t_mp_size = %d(%d)\n", a->_mp_size, 32 * (a->_mp_size - 1));
		printf("\t_mp_exp  = %d\n", a->_mp_exp);
		cdigits = mpn_get_str(mpfc, 10, a->_mp_d, abs(a->_mp_size));
		for(j = 0; j < cdigits; j++)
		{
			if((mpfc[j] >= 0) && (mpfc[j] <= 9))
				mpfc[j] += '0';
			else
				mpfc[j] += 'A';
		}
		printf("\t_mp_d    = %s\n", mpfc);
		
		mpf_clear(a);
	}
}
