/**********************************************/
/* test_mpq.c:                                */
/* Copyright (C) 2003 Tomonori Kouya          */
/*                                            */
/* This library is free software; you can re- */
/* distribute it and/or modify it under the   */
/* terms of the GNU Lesser General Public     */
/* License as published by the Free Software  */
/* Foundation; either version 2.1 of the      */
/* License, or (at your option) any later     */
/* version.                                   */
/*                                            */
/* This library is distributed in the hope    */
/* that it will be useful, but WITHOUT ANY    */
/* WARRANTY; without even the implied         */
/* warranty of MERCHANTABILITY or FITNESS FOR */
/* A PARTICULAR PURPOSE.  See the GNU Lesser  */
/* General Public License for more details.   */
/**********************************************/
/*************************************************/
/* Test Program using mpq datatype               */
/*************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include "bnc.h"

#define DIM 5

main()
{
#ifdef USE_GMP

	mpq_t qa, qb, qc;
	mpf_t fa;
	MPQVector qva, qvb;

	mpq_init(qa); mpq_init(qb); mpq_init(qc);
	mpf_init2(fa, 128);
	qva = init_mpqvector(DIM);
	qvb = init_mpqvector(DIM);

	mpq_set_ui(qa, 1UL, 2UL);
	mpq_set_str(qb, "1/3", 10);

	mpq_add(qc, qa, qb);

	mpq_out_str(stdout, 10, qa); printf(" + ");
	mpq_out_str(stdout, 10, qb); printf(" = ");
	mpq_out_str(stdout, 10, qc); printf("\n");

	/* vector */
	set_mpqvector_i_str(qva, 0, "12345678987654321/98765432123456789");
	set_mpqvector_i_ui(qva, 1, 987654321L, 123456789UL);
	set_mpqvector_i(qva, 2, qa);
	set_mpqvector_i(qva, 3, qb);
	set_mpqvector_i(qva, 4, qc);

	set_mpqvector_i_str(qvb, 0, "999/888");
	set_mpqvector_i_ui(qvb, 1, 888UL, 999UL);
	set_mpqvector_i(qvb, 2, qc);
	set_mpqvector_i(qvb, 3, qb);
	set_mpqvector_i(qvb, 4, qa);

	printf("qva:\n"); print_mpqvector(qva);
	printf("\n");
	printf("qvb:\n"); print_mpqvector(qvb);

	ip_mpqvector(qc, qva, qvb);
	printf("(qva, qvb) = "); mpq_out_str(stdout, 10, qc); printf("\n");
	mpq_get_f(fa, qc);
	printf("float -> "); mpf_out_str(stdout, 10, 0, fa); printf("\n");
	mpq_canonicalize(qc);
	printf("canonicalize -> "); mpq_out_str(stdout, 10, qc); printf("\n");
	mpq_get_f(fa, qc);
	printf("float -> "); mpf_out_str(stdout, 10, 0, fa); printf("\n");

	printf("canonicalize -> "); mpq_out_str(stdout, 10, qc); printf("\n");

	mpq_clear(qa); mpq_clear(qb); mpq_clear(qc);
	free_mpqvector(qva);
	free_mpqvector(qvb);
#endif
}

